/**
 *   Licensed to the Apache Software Foundation (ASF) under one
 *   or more contributor license agreements.  See the NOTICE file
 *   distributed with this work for additional information
 *   regarding copyright ownership.  The ASF licenses this file
 *   to you under the Apache License, Version 2.0 (the
 *   "License"); you may not use this file except in compliance
 *   with the License.  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

package com.qlangtech.tis.compiler.java;

import java.io.File;

/**
 * @author: 百岁（baisui@qlangtech.com）
 * @create: 2021-10-20 17:00
 **/
public class ResourcesFile {

    private final ZipPath zipPath;

    private final File file;

    public ResourcesFile(ZipPath zipPath, File file) {
        super();
        this.zipPath = zipPath;
        this.file = file;
    }

    public ZipPath getZipPath() {
        return zipPath;
    }

    public File getFile() {
        return file;
    }
}
